/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Die Okt 17 14:53:21 CEST 2000
    copyright            : (C) 2000 by Markus Fruehwirth
    email                : 7ox@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SJBfft.h"


/* name:fft
 * var: weight
 * exitcode:0 (for normal termination - returncode)
 * explanation: reads file and calls realft (nr)
*/
int
fft (int weight)
{
  int back;			//returnvalue
  FILE *read, *write;		//fileops
  int steps, *stepsp;		//iterations FFT
  int length, *lengthp;		//length in sec - useless
  float value, *valuep;		//current value
  float *data;			//array for FFT
  int lines;			//read that much lines
  char *line, *saveline;	//line
  int ready;			//eof
  int i;			//counter
  float calc, sum;		// i+steps/steps

//INIT
  value = 0;
  sum = 0;
  line = malloc (MAXLENLINE * sizeof (char));
  saveline = malloc (MAXLENLINE * sizeof (char));
  steps = 0;
  length = 0;
  stepsp = &steps;
  lengthp = &length;
  valuep = &value;
  lines = 0;
  ready = 0;

//read stdin
  read = stdin;

//read now parameters
  saveline = fgets (line, MAXLENLINE, read);

  if (saveline == NULL)
    ready = 5;

  back = sscanf (line, "%d %d", lengthp, stepsp);
  lines++;

  data = vector (1, steps);

  while (ready == 0)		//start reading data
    {
      saveline = fgets (line, MAXLENLINE, read);
//one line

//eof
      if (saveline == NULL)
	ready = 1;

      if (ready == 0)
	{
	  back = sscanf (line, "%f", valuep);

//copy to array
	  data[lines] = value;

	  lines++;
	}
    }

//lines counted in lines
  (void) fclose (read);
  free (line);
  free (saveline);

  if (ready != 5)
    {
      write = stdout;

//reading ready, calling now FFT
      realft (data, steps, FFTNORMAL);

      sum = (float) steps / (float) (steps - weight);
      for (i = 1; i <= steps; i++)
	{
	  //weigth data
	  if (weight == FALSE)
	    fprintf (write, "%f ", data[i]);
	  else
	    {
	      if (weight > i)
		fprintf (write, "%f ", data[i]);
	      else
		{		//don't do anything at the beginning, start with coefficient #weight
		  calc = 0;
		  calc =
		    (float) (steps -
			     (((float) (i - weight)) * sum)) / (float) steps;
		  fprintf (write, "%f ", data[i] * calc);
		}
	    }
	}

      (void) fflush (write);
    }
  free_vector (data, 1, steps);

  if (back > 0)
    back = 0;
  return back;
}


/* name: main
 * var: weighted (0-255)
 * exitcode:0 (for normal termination - returncode)
 * explanation: calls fft
*/
int
main (int argc, char *argv[])
{
  int back = -1;
  int weight, *weightp;		//length in sec

  weightp = &weight;

//convert arguments
  if (argc == 2)
    {
      back = sscanf (argv[1], "%d", weightp);
      if ((weight > -1) & (weight < 256))
	back = fft (weight);
      else
	
	  (void) fprintf (stderr, "%s: first argument out of range [0-255]\n",
			  argv[0]);
      exit (EXIT_FAILURE);
    }
  else
    {
      (void) fprintf (stderr, "%s: wrong Usage: %s gewichtet\n", argv[0], argv[0]);
      exit (EXIT_FAILURE);
    }
  return back;
}
