/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Mit Okt 18 14:29:45 CEST 2000
    copyright            : (C) 2000 by Markus Fruehwirth
    email                : 7ox@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SJBMajorVector.h"


/* name:vec
 * var: none
 * exitcode: 0
 * explanation: generate vectorfile
*/
int
vec ()
{
  int value;			//returnvalue
  FILE *file, *write, *reader, *error;
  char *savepath, *path;	//pathname
  char *filename, *oldfilename;	//filename
  char *line, *saveline;	//filename
  char *name, *temp;
  int bandf, piecef;		//band and seg
  int i, j;			//counter
  char current;			//letter
  int read, *readp;
  int start, cancel;
  long xdim;
  int vecdim;
  int oldbandf;
  int oldpiecef;


//INIT
  value = 0;
  piecef = 0;
  readp = &read;
  filename = malloc (MAXNAME * sizeof (char));
  oldfilename = malloc (MAXNAME * sizeof (char));
  name = malloc (MAXNAME * sizeof (char));
  temp = malloc (MAXLENLINE * sizeof (char));
  line = malloc (MAXLENLINE * sizeof (char));
  saveline = malloc (MAXLENLINE * sizeof (char));
  path = malloc (MAXLENLINE * sizeof (char));
  vecdim = 0;

  write = stdout;
  error = stderr;
  reader = stdin;

//read arguments
  saveline = fgets (line, MAXLENLINE, reader);

  i = 0;
  current = line[i];
  while (current != NEWLINE)
    {
      name[i] = current;
      i++;
      current = line[i];
    }
  name[i] = '\0';		//Name in name;
  i++;				//i at first number

//read path
  saveline = fgets (line, MAXLENLINE, reader);
  strncpy (path, line, strlen (line) - 1);
  strcat (path, "/");


//start with data
  oldbandf = -1;
  oldpiecef = -1;
  cancel = FALSE;
  xdim = 0;
  while (cancel == FALSE)
    {
      savepath = malloc (MAXLENLINE * sizeof (char));
      strcpy (savepath, path);

//read filename
      saveline = fgets (line, MAXLENLINE, reader);

      if (saveline == NULL)	//eof
	cancel = TRUE;

      if (cancel == FALSE)
	{
//extraktion of: Name, band, piece
	  i = 0;
	  current = line[i];
	  while (current != ASCIIDOT)
	    {
	      filename[i] = current;
	      i++;
	      current = line[i];
	    }
	  filename[i] = ASCIIDOT;
	  i++;
	  current = line[i];
//till second dot
	  while (current != ASCIIDOT)
	    {
	      filename[i] = current;
	      i++;
	      current = line[i];
	    }
	  filename[i] = '\0';	//filename OK

//extracting band
	  start = FALSE;
	  current = line[i];
	  while (start != TRUE)
	    {
	      while (current != ASCIIDOT)
		{
		  i++;
		  current = line[i];
		}
	      i++;
	      //this should be a number
	      current = line[i];
	      if ((current >= ASCIIZERO) && (current <= ASCIININE)
		  && (start == 2))
		{
		  j = 0;
		  while (current != ASCIIS)
		    {
		      temp[j] = current;
		      i++;
		      j++;
		      current = line[i];
		    }
		  temp[j] = ' ';	//Name in name;
		  value = sscanf (temp, "%d ", readp);
		  piecef = read;	//in piecef is segmentnumber of file
		  start = TRUE;
		}
	      if ((current >= ASCIIZERO) && (current <= ASCIININE)
		  && (start == FALSE))
		{
		  j = 0;
		  while (current != ASCIIDOT)
		    {
		      temp[j] = current;
		      i++;
		      j++;
		      current = line[i];
		    }
		  temp[j] = ' ';	//Name in name;
		  value = sscanf (temp, "%d ", readp);
		  bandf = read;	//in bandf is wave band of file
		  start = 2;
		}
	    }
//Filename in filename, band in bandf, segnr in piecef

//print name
	  if (oldpiecef > -1)
	    if ((strcmp (filename, oldfilename) != 0)
		|| (piecef != oldpiecef))
	      {
		xdim++;
		vecdim = 0;
		fprintf (write, "%s.-.%d.mp3\n", oldfilename, oldpiecef);
	      }

	  strcpy (oldfilename, filename);
	  oldbandf = bandf;
	  oldpiecef = piecef;
	  start = 1;

	  strncat (savepath, line, strlen (line) - 1);
	  file = fopen (savepath, "r");

	  current = fgetc (file);
	  while (current != EOF)
	    {
	      fprintf (write, "%c", current);
	      current = fgetc (file);
	      if (current == ASCIISPACE)
		vecdim++;
	    }
	  (void) fclose (file);
//file ready, next line
	}			//if cancel ==TRUE
      free (savepath);
    }				// while cancel

  xdim++;
  fprintf (write, "%s.-.%d.mp3\n", oldfilename, oldpiecef);

//print dim, vecdim, title in headerfile
  fprintf (error, "$TYPE %s\n$XDIM %ld\n$YDIM %d\n$VEC_DIM %d\n", name, xdim,
	   YDIM, vecdim);

  (void) fflush (write);
  (void) fflush (error);
  (void) fclose (reader);
  free (path);
  free (line);
  free (saveline);
  free (name);
  free (temp);
  free (oldfilename);
  free (filename);

  if (value > 0)
    value = 0;
  return value;
}


/* name:main
 * var: none
 * exitcode:0 (for normal termination - returncode)
 * explanation: calls vec
*/
int
main (int argc, char *argv[])
{
  int value = -1;

  if (argc == 1)
    value = vec ();
  else
    {
      (void) fprintf (stderr, "%s: wrong Usage: %s\n", argv[0], argv[0]);
      exit (EXIT_FAILURE);
    }
  return value;
}
