/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Die Oct 10 13:07:07 CEST 2000
    copyright            : (C) 2000 by Markus Fruehwirth
    email                : 7ox@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SJBsplit.h"


/* name: split
 * var: filename    name of output files
 * exitcode:0 (for normal termination - returncode)
 * explanation: splits stdin in single frequencys
*/
int
split (const char *filename)
{
  FILE *lies;			//read filepointer
  char *tfile;			//temp filenames
  char *cfile;			//copied filename
  char *number;			//gets its value from "inttochar"
  FILE *write[FRQSIZE];		//write here
  int i, j;			// counter
  int value;			//give that value back
  char cc;			//current character
  char *time;			//time
  char *line[FRQSIZE];		//one line
  int stop;			//end of file

// Init //
  cc = 0;
  value = 0;
  stop = 0;

  lies = stdin;

// open 256 filepointers
  tfile = malloc (256);
  strcpy (tfile, filename);
  strcat (tfile, ".");

  for (i = 0; i < FRQSIZE; i++)
    {
      cfile = malloc (256);
      strcpy (cfile, tfile);

      number = inttochar (i);
      strcat (cfile, number);

      strcat (cfile, ".temp\0");
      write[i] = fopen (cfile, "w");
      free (cfile);
    }

  time = malloc (10);
  for (i = 0; i < FRQSIZE; i++)
    line[i] = malloc (10);

// read File till the first T
  while (stop == 0)
    {

      while (cc != ASCIIT)	//cat beginning
	{
	  cc = fgetc (lies);
	  if (cc == EOF)
	    {
	      stop = 1;
	      cc = ASCIIT;
	    }
	}
//start now with first line, we are on first T

//read time
      if (stop == 0)
	{
	  i = 0;
	  while (cc != ASCIISLASH)	//read number
	    {
	      cc = fgetc (lies);
	      if (cc != ASCIISLASH)
		{
		  time[i] = cc;
		  i++;
		}
	    }
	  time[i] = '\0';
// time now in time

//read line (rest of the data)
	  for (i = 0; i < FRQSIZE; i++)
	    {
	      j = 0;
	      cc = ASCIIZERO;
	      while (cc != ASCIISLASH)	//read numbers
		{
		  cc = fgetc (lies);
		  if (cc != ASCIISLASH)
		    {
		      line[i][j] = cc;
		      j++;
		    }
		}
	      line[i][j] = '\0';
	    }
//whole line now in line[]

//print this line to the 256 files
	  for (i = 0; i < FRQSIZE; i++)
	    fprintf (write[i], "%s %s\n", time, line[i]);

	}
    }				//stop

  free (time);
  for (i = 0; i < FRQSIZE; i++)
    free (line[i]);

  (void) fclose (lies);
  for (i = 0; i < FRQSIZE; i++)
    (void) fclose (write[i]);

  return value;
}



/* name: inttochar
 * var: number  convert this integer
 * exitcode: the converted string
 * explanation: converts an interger to a character
*/
char *
inttochar (int number)
{
  char *result;			//result char
  int stop;			//gets 1 in case of an error, result: 000
  int temp;			//temp result
  int goon;			//if we have the value above 100 is ready
  int save;			//copy of number

//init
  stop = 0;
  goon = 0;
  result = malloc (6);
  result[0] = ASCIIZERO;
  result[1] = ASCIIZERO;
  result[2] = ASCIIZERO;
  save = number;

//range OK?
  if (number < 0)
    stop = 1;
  if (number > 255)
    stop = 1;

//conversion start
  if (stop == 0)
    {
      if (number > 199)
	{
	  result[0] = ASCIITWO;
	  number = number - 200;
	  goon = 1;
	}
      if ((number > 99) && (goon == 0))
	{
	  result[0] = ASCIIONE;
	  number = number - 100;
	}
//above 100 now finished
      temp = number % 10;	//last number OK.
      result[2] = ASCIIZERO + temp;
      temp = number / 10;	//second value in temp
      result[1] = ASCIIZERO + temp;
    }
//calculation finished
//removing leading zeros
  if (save < 100)
    {
      result[0] = result[1];
      result[1] = result[2];
      result[2] = result[3];
    }
  if (save < 10)
    {
      result[0] = result[1];
      result[1] = result[2];
      result[2] = result[3];
    }

  return result;
}


/* name: main
 * var: argv[1] Filename
 * exitcode:0 (for normal termination - returncode)
 * explanation: calls split function
*/
int
main (int argc, char *argv[])
{
  int value = -1;

  if (argc == 2)
    value = split (argv[1]);
  else
    {
      (void) fprintf (stderr, "%s: wrong Usage: %s filename\n", argv[0], argv[0]);
      exit (EXIT_FAILURE);
    }

  return value;
}
