/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Don Okt 12 09:58:43 CEST 2000
    copyright            : (C) 2000 by Markus Fruehwirth
    email                : 7ox@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SJBtime.h"

/* name: split
 * var: name of file, seconds for one file, difference
 * exitcode:0 (for normal termination - returncode)
 * explanation: split files in given length
*/
int
split (const char *filename, unsigned long int maintime,
       unsigned long int difference)
{
  int back;			//returnwert
  FILE *read;			//read from here
  FILE *write;			//write on that
  char *line, *saveline;	//current line
  int letter;			//converted letter from line
  unsigned long int *timep, time;	//measured time
  unsigned long int *valuep, value;	//measured value
  unsigned long int calctime;	//for calculation
  char *number;			//filenumber
  char *tfile;			//filenames
  char *cfile;			//filenames
  int filenr;			//which file
  int linenr;			//linenumber
  int ende;			//if end of file
  int stop;			//if end of line
  int i;			//counter


// Init
  ende = 0;
  linenr = 0;
  back = 0;
  line = malloc (MAXLENLINE * sizeof (char));
  saveline = malloc (MAXLENLINE * sizeof (char));
  time = 0;
  value = 0;
  valuep = &value;
  timep = &time;
  calctime = 0;
  filenr = -1;
  tfile = malloc (256);
  strcpy (tfile, filename);
  strcat (tfile, ".");

//outer loop to forward to the given length
  while (ende == 0)
    {
//read this file
      read = fopen (filename, "r");
      for (i = 0; i < linenr; i++)
	{
	  saveline = fgets (line, MAXLENLINE, read);
	  letter = sscanf (line, "%lu %lu", timep, valuep);

	  if (saveline == NULL)
	    letter = 10;

	  if (letter == 10)
	    {
	      ende = 1;
	      i = linenr;
	    }
	}			//for
// this is the right line
      if (ende == 1)
	break;

      ++filenr;
      cfile = malloc (256);
      strcpy (cfile, tfile);
      number = inttochar (filenr);
      strcat (cfile, number);
      strcat (cfile, "s\0");
      write = fopen (cfile, "w");
      free (cfile);
//writing file now open
      stop = 0;
      calctime = 0;
      while (stop < 5)
	{
//read line
	  saveline = fgets (line, MAXLENLINE, read);

//convert
	  letter = sscanf (line, "%lu %lu", timep, valuep);
	  if (saveline == NULL)
	    letter = 10;

	  if (letter == 10)
	    {
	      ende = 1;
	      stop = 2;
	    }
//time = time from file, value = value from file
	  if (stop == 0)	//first iteration
	    {
	      time = 0;		//set time to zero
	      stop = 1;
	    }

	  calctime = calctime + time;

	  if (stop == 2)
	    calctime = calctime + maintime + 1;	//stop writing

	  if (calctime < difference)	//write line
	    linenr++;

	  if (calctime < maintime)	//do the writing
	    fprintf (write, "%lu %lu\n", calctime, value);
	  else
	    {
	      stop = 10;
	      if (ende == 0)
		fprintf (write, "%lu %lu\n", calctime, value);
	    }

	}			//stop

      (void) fclose (read);
      (void) fclose (write);

    }				//ende

  free (tfile);
  free (line);
  free (saveline);
  return back;
}


/* name: inttochar
 * var: integer to convert
 * exitcode: converted character
 * explanation: converts an pos integer to a character (int must be smaller than 10000!)
*/
char *
inttochar (int number)
{
  char *result;			//converted result
  int stop;			//gets 1 in case of an error
  int e, z, h, t;
  int save;

//INIT
  result = malloc (6);
  stop = 0;
  save = number;
  result[0] = ASCIIZERO;

//range OK?
  if ((number >= 10000) || (number < 0))
    stop = 1;

  if (stop == 0)
    {
//below 10
      e = number % 10;
      number = number - e;
//below 100
      z = number % 100;
      number = number - z;
      z = z / 10;
//below 1000
      h = number % 1000;
      number = number - h;
      h = h / 100;
//below 10000
      t = number % 10000;
      number = number - t;
      t = t / 1000;

//removing leading zeros
      if ((save < 10) && (stop == 0))
	{
	  stop = 1;
	  result[0] = ASCIIZERO + e;
	}

      if ((save < 100) && (stop == 0))
	{
	  result[0] = ASCIIZERO + z;
	  result[1] = ASCIIZERO + e;
	  stop = 1;
	}
      if ((save < 1000) && (stop == 0))
	{
	  result[0] = ASCIIZERO + h;
	  result[1] = ASCIIZERO + z;
	  result[2] = ASCIIZERO + e;
	  stop = 1;
	}
      if ((save < 10000) && (stop == 0))
	{
	  result[0] = ASCIIZERO + t;
	  result[1] = ASCIIZERO + h;
	  result[2] = ASCIIZERO + z;
	  result[3] = ASCIIZERO + e;
	  stop = 1;
	}
    }
  return result;
}


/* name: main
 * var: name of file, seconds for one file, diff
 * exitcode:0 (for normal termination - returncode)
 * explanation: processes file
*/
int
main (int argc, char *argv[])
{
  int back = -1;		//returnvalue
  int maintime;			//time for a file
  int difference;		//difference

  if (argc == 4)
    {
      //convert commandline
      maintime = (unsigned long int) (argv[2][0] - ASCIIZERO);
      difference = (unsigned long int) (argv[3][0] - ASCIIZERO);
      //test arguments
      if ((maintime > 0) && (maintime < 61) && (difference > 0)
	  && (difference <= maintime))
	back = split (argv[1], maintime * MICROSEC, difference * MICROSEC);
      else
	{
	  
	    (void) fprintf (stderr,
			    "%s: wrong Usage: %s filename length diff\n",
			    argv[0], argv[0]);
	  exit (EXIT_FAILURE);
	}
    }
  else
    {
      
	(void) fprintf (stderr, "%s: wrong Usage: %s filename length diff\n",
			argv[0], argv[0]);
      exit (EXIT_FAILURE);
    }

  return back;
}
